diff --git a/mobile/lib/screens/public_event/public_event_screen.dart b/mobile/lib/screens/public_event/public_event_screen.dart
index 9c8890e..2e2f3b3 100644
--- a/mobile/lib/screens/public_event/public_event_screen.dart
+++ b/mobile/lib/screens/public_event/public_event_screen.dart
@@ -21,117 +25,809 @@ class PublicEventScreen extends StatefulWidget {
 }
 
 class _PublicEventScreenState extends State<PublicEventScreen> {
-  late final PublicEventService _service = widget.service ?? PublicEventService();
+  late final PublicEventService _service =
+      widget.service ?? PublicEventService();
   bool _loading = true;
   String? _error;
   PublicEvent? _eventModel;
   List<PublicParticipant> _participants = const [];
   List<PublicTeam> _teams = const [];
-  final Map<String, String> _scoreStates = {}; // key: pid-g -> idle|saving|saved|error
+  String? _clubName;
+  final Map<String, String> _scoreStates =
+      {}; // key: pid-g -> idle|saving|saved|error
   final Map<String, Timer> _debouncers = {};
   final Map<String, Timer> _postTimers = {};
-  _ResultSort _resultSort = _ResultSort.total;
-
-  String _statusLabel(EventStatus s) {
-    switch (s) {
-      case EventStatus.ready:
-        return 'ready';
-      case EventStatus.active:
-        return 'active';
-      case EventStatus.completed:
-        return 'completed';
-      case EventStatus.canceled:
-        return 'canceled';
-      default:
-        return 'unknown';
-    }
-  }
-
-  Color _statusColor(EventStatus s) {
-    switch (s) {
-      case EventStatus.ready:
-        return Colors.blue.shade50;
-      case EventStatus.active:
-        return Colors.green.shade50;
-      case EventStatus.completed:
-        return Colors.grey.shade200;
-      case EventStatus.canceled:
-        return Colors.red.shade50;
-      default:
-        return Colors.grey.shade100;
-    }
-  }
-
-  String _typeLabel(EventType t) {
-    switch (t) {
-      case EventType.regular:
-        return 'regular';
-      case EventType.tournament:
-        return 'tournament';
-      case EventType.practice:
-        return 'practice';
-      case EventType.league:
-        return 'league';
-      default:
-        return 'unknown';
-    }
-  }
-
-  String _participantStatusLabel(ParticipantStatus s) {
-    switch (s) {
-      case ParticipantStatus.pending:
-        return 'pending';
-      case ParticipantStatus.confirmed:
-        return 'confirmed';
-      case ParticipantStatus.canceled:
-        return 'canceled';
-      default:
-        return 'unknown';
-    }
-  }
-
-  String _paymentLabel(PaymentStatus s) {
-    switch (s) {
-      case PaymentStatus.paid:
-        return 'paid';
-      case PaymentStatus.unpaid:
-        return 'unpaid';
-      case PaymentStatus.refunded:
-        return 'refunded';
-      case PaymentStatus.partial:
-        return 'partial';
-      default:
-        return 'unknown';
-    }
-  }
+  final Map<int, bool> _teamExpanded = {};
+  Timer? _refreshDebounce;
+  int _savedTabIndex = 0;
+  bool _tabListenerAttached = false;
+  bool _personalTableView = false; // 개인별 보기 전환 상태
 
   @override
   void initState() {
     super.initState();
+    // 최초 진입 시 공개 이벤트 데이터 로드
     _load();
+    _loadUiPrefs();
   }
 
-  Color _scoreColor(PublicParticipant p, int g) {
-    final idx = g - 1;
-    int base = 0;
-    if (idx >= 0 && idx < p.rawScores.length && p.rawScores[idx] != null) {
-      base = p.rawScores[idx]!;
+  Future<void> _savePersonalViewPref(bool table) async {
+    try {
+      final prefs = await SharedPreferences.getInstance();
+      await prefs.setBool(_prefsKey('personalTableView'), table);
+    } catch (_) {}
+  }
+
+  String _fmt2(int n) => n.toString().padLeft(2, '0');
+  String _fmtLocal(DateTime dt) {
+    final l = dt.toLocal();
+    return '${l.year}-${_fmt2(l.month)}-${_fmt2(l.day)} ${_fmt2(l.hour)}:${_fmt2(l.minute)}';
+  }
+
+  String _prefsKey(String name) => 'publicEvent/${widget.publicHash}/$name';
+
+  Future<void> _loadUiPrefs() async {
+    try {
+      final prefs = await SharedPreferences.getInstance();
+      final rawIndex = prefs.getInt(_prefsKey('tabIndex'));
+      if (rawIndex == null || (rawIndex != 0 && rawIndex != 1)) {
+        _savedTabIndex = 0;
+        await prefs.setInt(_prefsKey('tabIndex'), 0);
+      } else {
+        _savedTabIndex = rawIndex;
+      }
+      final teamJson = prefs.getString(_prefsKey('teamExpanded'));
+      if (teamJson != null && teamJson.isNotEmpty) {
+        final decoded = jsonDecode(teamJson);
+        if (decoded is Map) {
+          _teamExpanded.clear();
+          decoded.forEach((k, v) {
+            final key = int.tryParse(k.toString());
+            if (key != null) {
+              _teamExpanded[key] = v == true;
+            }
+          });
+        }
+      }
+      // 개인별 보기 전환 상태 복원 (기본값: false -> 카드형)
+      final pv = prefs.getBool(_prefsKey('personalTableView'));
+      _personalTableView = pv == true;
+      if (mounted) setState(() {});
+    } catch (_) {}
+  }
+
+  Future<void> _saveTabIndex(int index) async {
+    try {
+      final prefs = await SharedPreferences.getInstance();
+      await prefs.setInt(_prefsKey('tabIndex'), index);
+    } catch (_) {}
+  }
+
+  Future<void> _saveTeamExpandedPrefs() async {
+    try {
+      final prefs = await SharedPreferences.getInstance();
+      final map = <String, bool>{};
+      _teamExpanded.forEach((k, v) => map[k.toString()] = v);
+      await prefs.setString(_prefsKey('teamExpanded'), jsonEncode(map));
+    } catch (_) {}
+  }
+
+  int? _rankForParticipant(String id, Map<String, Map> rankMap) {
+    final data = rankMap[id];
+    if (data == null) return null;
+    final val = data['rank'];
+    if (val is int) return val;
+    return int.tryParse((val ?? '').toString());
+  }
+
+  Future<void> _saveInlineHandicap(
+    PublicParticipant p,
+    int gameNumber,
+    int handicap,
+  ) async {
+    final key = _keyFor(p.participantId, gameNumber);
+    _scoreStates[key] = 'saving';
+    setState(() {});
+    try {
+      // Use the latest score from current state to avoid sending stale value
+      int currentScore = 0;
+      final idxNow = _participants.indexWhere((pp) => pp.participantId == p.participantId);
+      if (idxNow >= 0) {
+        final now = _participants[idxNow];
+        if (gameNumber - 1 >= 0 && gameNumber - 1 < now.rawScores.length) {
+          currentScore = now.rawScores[gameNumber - 1] ?? 0;
+        }
+      } else {
+        currentScore = p.rawScores[gameNumber - 1] ?? 0;
+      }
+      await _service.updateScore(
+        widget.publicHash,
+        participantId: p.participantId,
+        gameNumber: gameNumber,
+        score: currentScore,
+        handicap: handicap,
+      );
+      final idx = _participants.indexWhere(
+        (pp) => pp.participantId == p.participantId,
+      );
+      if (idx >= 0) {
+        final cur = _participants[idx];
+        final newHc = List<int>.from(cur.handicaps);
+        if (gameNumber >= 1 && gameNumber <= newHc.length) {
+          newHc[gameNumber - 1] = handicap;
+        }
+        final updated = PublicParticipant(
+          participantId: cur.participantId,
+          memberId: cur.memberId,
+          name: cur.name,
+          gender: cur.gender,
+          memberType: cur.memberType,
+          average: cur.average,
+          handicap: cur.handicap,
+          status: cur.status,
+          paymentStatus: cur.paymentStatus,
+          comment: cur.comment,
+          isGuest: cur.isGuest,
+          rawScores: cur.rawScores,
+          handicaps: newHc,
+        );
+        final newList = List<PublicParticipant>.from(_participants);
+        newList[idx] = updated;
+        _participants = newList;
+      }
+      _scoreStates[key] = 'saved';
+      setState(() {});
+      _postTimers[key]?.cancel();
+      _postTimers[key] = Timer(const Duration(milliseconds: 1200), () {
+        if (!mounted) return;
+        _scoreStates[key] = 'idle';
+        setState(() {});
+      });
+      _refreshDebounce?.cancel();
+      _refreshDebounce = Timer(const Duration(milliseconds: 400), () {
+        if (!mounted) return;
+        _load();
+      });
+    } catch (_) {
+      _scoreStates[key] = 'error';
+      setState(() {});
     }
-    int hc = 0;
-    if (idx >= 0 && idx < p.handicaps.length) {
-      hc = p.handicaps[idx];
+  }
+
+  Future<void> _saveTeamMemberHandicap(
+    int teamNumber,
+    PublicTeamMemberSummary m,
+    int gameNumber,
+    int handicap,
+  ) async {
+    final key = _keyFor(m.participantId ?? '0', gameNumber);
+    _scoreStates[key] = 'saving';
+    setState(() {});
+    try {
+      // Use the latest score from current state to avoid sending stale value
+      int currentScore = 0;
+      final tIdxNow = _teams.indexWhere((tt) => tt.teamNumber == teamNumber);
+      if (tIdxNow >= 0) {
+        final teamNow = _teams[tIdxNow];
+        final mIdxNow = teamNow.members.indexWhere((mm) => mm.participantId == m.participantId);
+        if (mIdxNow >= 0) {
+          final mm = teamNow.members[mIdxNow];
+          if (gameNumber - 1 >= 0 && gameNumber - 1 < mm.rawScores.length) {
+            currentScore = mm.rawScores[gameNumber - 1] ?? 0;
+          }
+        }
+      } else {
+        currentScore = m.rawScores[gameNumber - 1] ?? 0;
+      }
+      await _service.updateScore(
+        widget.publicHash,
+        participantId: m.participantId!,
+        gameNumber: gameNumber,
+        score: currentScore,
+        handicap: handicap,
+        teamNumber: teamNumber,
+      );
+      final tIdx = _teams.indexWhere((tt) => tt.teamNumber == teamNumber);
+      if (tIdx >= 0) {
+        final team = _teams[tIdx];
+        final members = List<PublicTeamMemberSummary>.from(team.members);
+        final mIdx = members.indexWhere(
+          (mm) => mm.participantId == m.participantId,
+        );
+        if (mIdx >= 0) {
+          final cur = members[mIdx];
+          final newHc = List<int>.from(cur.handicaps);
+          if (gameNumber >= 1 && gameNumber <= newHc.length) {
+            newHc[gameNumber - 1] = handicap;
+          }
+          members[mIdx] = PublicTeamMemberSummary(
+            participantId: cur.participantId,
+            memberId: cur.memberId,
+            name: cur.name,
+            gender: cur.gender,
+            memberType: cur.memberType,
+            status: cur.status,
+            paymentStatus: cur.paymentStatus,
+            comment: cur.comment,
+            isGuest: cur.isGuest,
+            rawScores: cur.rawScores,
+            handicaps: newHc,
+            average: cur.average,
+            memberHandicap: cur.memberHandicap,
+          );
+          final updatedTeam = PublicTeam(
+            teamId: team.teamId,
+            teamNumber: team.teamNumber,
+            handicap: team.handicap,
+            members: members,
+          );
+          final newTeams = List<PublicTeam>.from(_teams);
+          newTeams[tIdx] = updatedTeam;
+          _teams = newTeams;
+        }
+      }
+      _scoreStates[key] = 'saved';
+      setState(() {});
+      _postTimers[key]?.cancel();
+      _postTimers[key] = Timer(const Duration(milliseconds: 1200), () {
+        if (!mounted) return;
+        _scoreStates[key] = 'idle';
+        setState(() {});
+      });
+      _refreshDebounce?.cancel();
+      _refreshDebounce = Timer(const Duration(milliseconds: 400), () {
+        if (!mounted) return;
+        _load();
+      });
+    } catch (_) {
+      _scoreStates[key] = 'error';
+      setState(() {});
     }
-    final total = base + hc;
-    if (base == 0) return Colors.grey;
-    return total >= 200 ? Colors.red : Colors.black87;
+  }
+
+  Widget _buildTeamSection(
+    PublicEvent? event,
+    List<PublicTeam> teams,
+    Map<int, Map> teamRankMap,
+    bool canInputScore,
+  ) {
+    return Column(
+      crossAxisAlignment: CrossAxisAlignment.start,
+      children: [
+        const SizedBox(height: 24),
+        Text('총 ${teams.length}팀', key: const Key('teams_count')),
+        const SizedBox(height: 8),
+        teams.isEmpty
+            ? const ListTile(key: Key('empty_teams'), title: Text('팀이 없습니다'))
+            : Column(
+                children: [
+                  for (final t in teams)
+                    Padding(
+                      padding: const EdgeInsets.symmetric(
+                        vertical: 6,
+                        horizontal: 8,
+                      ),
+                      child: Stack(
+                        clipBehavior: Clip.none,
+                        children: [
+                          Container(
+                            decoration: BoxDecoration(
+                              color: Colors.grey.shade100,
+                              borderRadius: BorderRadius.circular(12),
+                              border: Border.all(color: Colors.grey.shade300),
+                            ),
+                            padding: const EdgeInsets.all(12),
+                            child: Column(
+                              crossAxisAlignment: CrossAxisAlignment.start,
+                              children: [
+                                Row(
+                                  children: [
+                                    Container(
+                                      padding: const EdgeInsets.symmetric(
+                                        horizontal: 10,
+                                        vertical: 4,
+                                      ),
+                                      decoration: BoxDecoration(
+                                        color: Colors.blueGrey.withOpacity(
+                                          0.08,
+                                        ),
+                                        borderRadius: BorderRadius.circular(12),
+                                        border: Border.all(
+                                          color: Colors.blueGrey.withOpacity(
+                                            0.25,
+                                          ),
+                                        ),
+                                      ),
+                                      child: Text(
+                                        '팀 ${t.teamNumber}',
+                                        style: const TextStyle(
+                                          fontSize: 13,
+                                          fontWeight: FontWeight.w700,
+                                          color: Colors.black87,
+                                        ),
+                                      ),
+                                    ),
+                                    const SizedBox(width: 6),
+                                    Text(
+                                      '${t.members.length}명',
+                                      style: TextStyle(
+                                        fontSize: 12,
+                                        color: Colors.black.withOpacity(0.55),
+                                      ),
+                                    ),
+                                    const SizedBox(width: 4),
+                                    // Team total & average on header row
+                                    Builder(
+                                      builder: (context) {
+                                        int membersTotal = 0;
+                                        int validGames = 0; // 유효 게임 수(0 제외)
+                                        for (final m in t.members) {
+                                          int mt = 0;
+                                          for (
+                                            int i = 0;
+                                            i < m.rawScores.length;
+                                            i++
+                                          ) {
+                                            final raw = m.rawScores[i];
+                                            final hc = (i < m.handicaps.length)
+                                                ? m.handicaps[i]
+                                                : 0;
+                                            if (raw == null) continue;
+                                            mt += PublicRankingUtils.capScore(
+                                              raw + hc,
+                                            );
+                                            if (raw > 0) validGames++;
+                                          }
+                                          membersTotal += mt;
+                                        }
+                                        final total = membersTotal + t.handicap;
+                                        final avg = validGames > 0
+                                            ? (total / validGames)
+                                                  .toStringAsFixed(1)
+                                            : '-';
+                                        return Container(
+                                          padding: const EdgeInsets.symmetric(
+                                            horizontal: 8,
+                                            vertical: 4,
+                                          ),
+                                          decoration: BoxDecoration(
+                                            color: Colors.blueGrey.withOpacity(
+                                              0.08,
+                                            ),
+                                            borderRadius: BorderRadius.circular(
+                                              12,
+                                            ),
+                                            border: Border.all(
+                                              color: Colors.blueGrey
+                                                  .withOpacity(0.25),
+                                            ),
+                                          ),
+                                          child: Text(
+                                            '총 $total · 평균 $avg',
+                                            style: const TextStyle(
+                                              fontSize: 12,
+                                              fontWeight: FontWeight.w600,
+                                              color: Colors.blueGrey,
+                                            ),
+                                          ),
+                                        );
+                                      },
+                                    ),
+                                    if (canInputScore)
+                                      Container(
+                                        width: 65,
+                                        margin: const EdgeInsets.only(
+                                          left: 6,
+                                        ), // 원하는 값
+                                        child: Stack(
+                                          clipBehavior: Clip.none,
+                                          children: [
+                                            TextFormField(
+                                              key: Key(
+                                                'team_hc_input_${t.teamNumber}',
+                                              ),
+                                              initialValue: t.handicap
+                                                  .toString(),
+                                              keyboardType:
+                                                  TextInputType.number,
+                                              decoration: const InputDecoration(
+                                                isDense: true,
+                                                labelText: '팀 핸디캡',
+                                                floatingLabelBehavior:
+                                                    FloatingLabelBehavior.auto,
+                                                labelStyle: TextStyle(
+                                                  fontSize: 10,
+                                                ),
+                                                floatingLabelStyle: TextStyle(
+                                                  fontSize: 10,
+                                                ),
+                                                counterText: '',
+                                                contentPadding:
+                                                    EdgeInsets.symmetric(
+                                                      horizontal: 8,
+                                                      vertical: 8,
+                                                    ),
+                                              ),
+                                              maxLength: 3,
+                                              style: TextStyle(fontSize: 14),
+                                              onChanged: (v) async {
+                                                final k = _teamKey(
+                                                  t.teamNumber,
+                                                );
+                                                final val = int.tryParse(v);
+                                                if (val == null ||
+                                                    val < 0 ||
+                                                    val > 300)
+                                                  return;
+                                                _scoreStates[k] = 'saving';
+                                                setState(() {});
+                                                _debouncers[k]?.cancel();
+                                                _debouncers[k] = Timer(
+                                                  const Duration(
+                                                    milliseconds: 500,
+                                                  ),
+                                                  () async {
+                                                    try {
+                                                      await _service
+                                                          .updateTeamHandicap(
+                                                            widget.publicHash,
+                                                            teamNumber:
+                                                                t.teamNumber,
+                                                            handicap: val,
+                                                          );
+                                                      final idx = _teams
+                                                          .indexWhere(
+                                                            (tt) =>
+                                                                tt.teamNumber ==
+                                                                t.teamNumber,
+                                                          );
+                                                      if (idx >= 0) {
+                                                        _teams[idx] = PublicTeam(
+                                                          teamId: _teams[idx]
+                                                              .teamId,
+                                                          teamNumber:
+                                                              _teams[idx]
+                                                                  .teamNumber,
+                                                          handicap: val,
+                                                          members: _teams[idx]
+                                                              .members,
+                                                        );
+                                                      }
+                                                      _scoreStates[k] = 'saved';
+                                                      setState(() {});
+                                                      _postTimers[k]?.cancel();
+                                                      _postTimers[k] = Timer(
+                                                        const Duration(
+                                                          milliseconds: 1200,
+                                                        ),
+                                                        () {
+                                                          if (!mounted) return;
+                                                          _scoreStates[k] =
+                                                              'idle';
+                                                          setState(() {});
+                                                        },
+                                                      );
+                                                    } on DioException catch (
+                                                      e
+                                                    ) {
+                                                      final status = e
+                                                          .response
+                                                          ?.statusCode;
+                                                      if (status == 401 ||
+                                                          status == 403) {
+                                                        if (!mounted) return;
+                                                        Navigator.of(
+                                                          context,
+                                                        ).pushReplacement(
+                                                          MaterialPageRoute(
+                                                            builder: (_) =>
+                                                                PublicEventEntryScreen(
+                                                                  publicHash: widget
+                                                                      .publicHash,
+                                                                ),
+                                                          ),
+                                                        );
+                                                        return;
+                                                      }
+                                                      _scoreStates[k] = 'error';
+                                                      setState(() {});
+                                                    } catch (_) {
+                                                      _scoreStates[k] = 'error';
+                                                      setState(() {});
+                                                    }
+                                                  },
+                                                );
+                                              },
+                                            ),
+                                          ],
+                                        ),
+                                      ),
+                                    if (!canInputScore && t.handicap != 0)
+                                      Flexible(
+                                        child: Text(
+                                          '팀 핸디캡 ${t.handicap}',
+                                          key: Key(
+                                            'team_hc_text_${t.teamNumber}',
+                                          ),
+                                          overflow: TextOverflow.ellipsis,
+                                        ),
+                                      ),
+                                    const SizedBox(width: 6),
+                                    const Spacer(),
+                                    IconButton(
+                                      iconSize: 18,
+                                      padding: EdgeInsets.zero,
+                                      constraints: const BoxConstraints(
+                                        minWidth: 24,
+                                        minHeight: 28,
+                                      ),
+                                      icon: Icon(
+                                        (_teamExpanded[t.teamNumber] ?? true)
+                                            ? Icons.expand_less
+                                            : Icons.expand_more,
+                                      ),
+                                      onPressed: () {
+                                        final v =
+                                            _teamExpanded[t.teamNumber] ?? true;
+                                        _teamExpanded[t.teamNumber] = !v;
+                                        setState(() {});
+                                        _saveTeamExpandedPrefs();
+                                      },
+                                    ),
+                                  ],
+                                ),
+                                const SizedBox(height: 6),
+                                const SizedBox(height: 6),
+                                if ((_teamExpanded[t.teamNumber] ?? true))
+                                  Column(
+                                    crossAxisAlignment:
+                                        CrossAxisAlignment.start,
+                                    children: [
+                                      for (
+                                        int i = 0;
+                                        i < t.members.length;
+                                        i++
+                                      ) ...[
+                                        Padding(
+                                          padding: const EdgeInsets.symmetric(
+                                            vertical: 6,
+                                          ),
+                                          child: InkWell(
+                                            // Popup removed: tapping team member no longer opens a dialog.
+                                            child: Column(
+                                              crossAxisAlignment:
+                                                  CrossAxisAlignment.start,
+                                              children: [
+                                                PublicUserNameRow(
+                                                  name: t.members[i].name,
+                                                  gender: t.members[i].gender,
+                                                  memberType:
+                                                      t.members[i].memberType,
+                                                  userHandicap:
+                                                      t
+                                                              .members[i]
+                                                              .memberHandicap ==
+                                                          0
+                                                      ? null
+                                                      : t
+                                                            .members[i]
+                                                            .memberHandicap,
+                                                  userAverage:
+                                                      t.members[i].average ??
+                                                      _calcAvg(
+                                                        t.members[i].rawScores,
+                                                      )?.toDouble(),
+                                                ),
+                                                const SizedBox(height: 6),
+                                                PublicUserChipsRow(
+                                                  status: t.members[i].status,
+                                                  paymentStatus: t
+                                                      .members[i]
+                                                      .paymentStatus,
+                                                  memberType:
+                                                      t.members[i].memberType,
+                                                ),
+                                                const SizedBox(height: 6),
+                                                if (event != null)
+                                                  PublicUserGameEditors(
+                                                    gameCount: event.gameCount,
+                                                    participantId:
+                                                        t
+                                                            .members[i]
+                                                            .participantId ??
+                                                        '0',
+                                                    rawScores:
+                                                        t.members[i].rawScores,
+                                                    handicaps:
+                                                        t.members[i].handicaps,
+                                                    enabled: canInputScore,
+                                                    keyFor: _keyFor,
+                                                    stateIcon: _stateIcon,
+                                                    onScoreChanged: (g, val) =>
+                                                        _saveTeamMemberScoreDebounced(
+                                                          t.teamNumber,
+                                                          t.members[i],
+                                                          g,
+                                                          val,
+                                                        ),
+                                                    onHandicapChanged: (g, val) =>
+                                                        _saveTeamMemberHandicapDebounced(
+                                                          t.teamNumber,
+                                                          t.members[i],
+                                                          g,
+                                                          val,
+                                                        ),
+                                                    eventAverage: _calcAvg(
+                                                      t.members[i].rawScores,
+                                                    )?.toDouble(),
+                                                    memberHandicap: t
+                                                        .members[i]
+                                                        .memberHandicap,
+                                                  ),
+                                              ],
+                                            ),
+                                          ),
+                                        ),
+                                        if (i < t.members.length - 1)
+                                          const Divider(
+                                            height: 12,
+                                            thickness: 0.6,
+                                          ),
+                                      ],
+                                    ],
+                                  ),
+                              ],
+                            ),
+                          ),
+                          Positioned(
+                            top: -8,
+                            left: -8,
+                            child: KeyedSubtree(
+                              key: Key('team_rank_${t.teamNumber}'),
+                              child: _rankBadge(
+                                teamRankMap[t.teamNumber]?['rank'] as int?,
+                              ),
+                            ),
+                          ),
+                        ],
+                      ),
+                    ),
+                ],
+              ),
+      ],
+    );
+  }
+
+  Future<void> _saveTeamMemberScore(
+    int teamNumber,
+    PublicTeamMemberSummary m,
+    int gameNumber,
+    int score,
+  ) async {
+    if (m.participantId == null || m.participantId!.isEmpty) return;
+    final key = _keyFor(m.participantId!, gameNumber);
+    _scoreStates[key] = 'saving';
+    setState(() {});
+    try {
+      await _service.updateScore(
+        widget.publicHash,
+        participantId: m.participantId!,
+        gameNumber: gameNumber,
+        score: score,
+        teamNumber: teamNumber,
+      );
+      final tIdx = _teams.indexWhere((tt) => tt.teamNumber == teamNumber);
+      if (tIdx >= 0) {
+        final team = _teams[tIdx];
+        final members = List<PublicTeamMemberSummary>.from(team.members);
+        final mIdx = members.indexWhere(
+          (mm) => mm.participantId == m.participantId,
+        );
+        if (mIdx >= 0) {
+          final cur = members[mIdx];
+          final newScores = List<int?>.from(cur.rawScores);
+          if (gameNumber >= 1 && gameNumber <= newScores.length) {
+            newScores[gameNumber - 1] = score;
+          }
+          members[mIdx] = PublicTeamMemberSummary(
+            participantId: cur.participantId,
+            memberId: cur.memberId,
+            name: cur.name,
+            gender: cur.gender,
+            memberType: cur.memberType,
+            status: cur.status,
+            paymentStatus: cur.paymentStatus,
+            comment: cur.comment,
+            isGuest: cur.isGuest,
+            rawScores: newScores,
+            handicaps: cur.handicaps,
+            average: cur.average,
+            memberHandicap: cur.memberHandicap,
+          );
+          final updatedTeam = PublicTeam(
+            teamId: team.teamId,
+            teamNumber: team.teamNumber,
+            handicap: team.handicap,
+            members: members,
+          );
+          final newTeams = List<PublicTeam>.from(_teams);
+          newTeams[tIdx] = updatedTeam;
+          _teams = newTeams;
+        }
+      }
+      _scoreStates[key] = 'saved';
+      setState(() {});
+      _postTimers[key]?.cancel();
+      _postTimers[key] = Timer(const Duration(milliseconds: 1200), () {
+        if (!mounted) return;
+        _scoreStates[key] = 'idle';
+        setState(() {});
+      });
+      _refreshDebounce?.cancel();
+      _refreshDebounce = Timer(const Duration(milliseconds: 400), () {
+        if (!mounted) return;
+        _load();
+      });
+    } catch (_) {
+      _scoreStates[key] = 'error';
+      setState(() {});
+    }
+  }
+
+  double? _calcAvg(List<int?> raw) {
+    final vals = raw.whereType<int>().toList();
+    if (vals.isEmpty) return null;
+    final sum = vals.fold<int>(0, (a, b) => a + b);
+    return sum / vals.length;
   }
 
   Widget _stateIcon(String key) {
     final st = _scoreStates[key];
-    if (st == 'saving') return const Icon(Icons.autorenew, size: 14, color: Colors.grey);
-    if (st == 'saved') return const Icon(Icons.check_circle, size: 14, color: Colors.green);
-    if (st == 'error') return const Icon(Icons.error_outline, size: 14, color: Colors.orange);
-    return const Icon(Icons.circle, size: 10, color: Colors.grey);
+    if (st == 'saving') {
+      return const Icon(Icons.autorenew, size: 14, color: Colors.grey);
+    }
+    if (st == 'saved') {
+      return const Icon(Icons.check_circle, size: 14, color: Colors.green);
+    }
+    if (st == 'error') {
+      return const Icon(Icons.error_outline, size: 14, color: Colors.orange);
+    }
+    return const SizedBox.shrink();
+  }
+
+  Widget _rankBadge(int? rank) {
+    final r = rank ?? 0;
+    Color bg;
+    Color fg;
+    String label;
+    if (r == 1) {
+      bg = Colors.amber.shade100;
+      fg = Colors.amber.shade900;
+      label = '1위';
+    } else if (r == 2) {
+      bg = Colors.blueGrey.shade100;
+      fg = Colors.blueGrey.shade900;
+      label = '2위';
+    } else if (r == 3) {
+      bg = Colors.brown.shade100;
+      fg = Colors.brown.shade900;
+      label = '3위';
+    } else {
+      bg = Colors.blue.shade50;
+      fg = Colors.blueGrey.shade700;
+      label = (r > 0) ? ('R $r') : 'R -';
+    }
+    return Container(
+      padding: const EdgeInsets.symmetric(horizontal: 6, vertical: 2),
+      decoration: BoxDecoration(
+        color: bg,
+        borderRadius: BorderRadius.circular(10),
+      ),
+      child: Text(
+        label,
+        style: TextStyle(fontSize: 12, color: fg, fontWeight: FontWeight.w600),
+      ),
+    );
   }
 
   @override
